Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  class Global extends SymbolTable with Closeable with CompilationUnits with Plugins with PhaseAssembly with Trees with Printers with DocComments with Positions with Reporting with Parsing
  Definition Classes
    nsc
- AbstractTypeRef
- AbstractTypeSymbol
- AliasTypeRef
- AliasTypeSymbol
- Alternative
- Alternative
- AlternativeApi
- AlternativeExtractor
- Annotatable
- Annotated
- Annotated
- AnnotatedApi
- AnnotatedExtractor
- AnnotatedType
- AnnotatedType
- AnnotatedTypeApi
- AnnotatedTypeExtractor
- AnnotationApi
- AnnotationChecker
- AnnotationExtractor
- AnnotationFilter
- AnnotationInfo
- AnnotationInfo
- AntiPolyType
- AppliedTypeTree
- AppliedTypeTree
- AppliedTypeTreeApi
- AppliedTypeTreeExtractor
- AppliedTypeVar
- Apply
- Apply
- ApplyApi
- ApplyDynamic
- ApplyExtractor
- ApplyImplicitView
- ApplyToImplicitArgs
- ApproximateDependentMap
- ArgsTypeRef
- ArrayAnnotArg
- ArrayValue
- AsSeenFromMap
- Assign
- Assign
- AssignApi
- AssignExtractor
- Attachable
- BackquotedIdentifierAttachment
- BaseTypeSeq
- Bind
- Bind
- BindApi
- BindExtractor
- Block
- Block
- BlockApi
- BlockExtractor
- BooleanFlag
- BooleanFlag
- BoundedWildcardType
- BoundedWildcardType
- BoundedWildcardTypeApi
- BoundedWildcardTypeExtractor
- CannotHaveAttrs
- CaseDef
- CaseDef
- CaseDefApi
- CaseDefExtractor
- ChangeOwnerTraverser
- ChildSolidDescendantsCollector
- ClassDef
- ClassDef
- ClassDefApi
- ClassDefExtractor
- ClassInfoType
- ClassInfoType
- ClassInfoTypeApi
- ClassInfoTypeExtractor
- ClassMirror
- ClassSymbol
- ClassSymbolApi
- ClassUnwrapper
- ClassfileAnnotArg
- CodePrinter
- CollectTreeTraverser
- CollectTypeCollector
- CommonNames
- CommonOwnerMap
- CompactTreePrinter
- CompatApi
- CompatToken
- CompilationUnit
- CompilationUnitContextApi
- CompleteAnnotationInfo
- CompoundType
- CompoundType
- CompoundTypeApi
- CompoundTypeTree
- CompoundTypeTree
- CompoundTypeTreeApi
- CompoundTypeTreeExtractor
- CompoundTypeTreeOriginalAttachment
- ConsoleWriter
- Constant
- Constant
- ConstantApi
- ConstantExtractor
- ConstantType
- ConstantType
- ConstantTypeApi
- ConstantTypeExtractor
- ConstructorNeedsFence
- ContainsAnyCollector
- ContainsAnyKeyCollector
- ContainsCollector
- CyclicReference
- DefDef
- DefDef
- DefDefApi
- DefDefExtractor
- DefTree
- DefTreeApi
- DefaultPosAssigner
- DefinitionsApi
- DefinitionsClass
- DelambdafyTarget
- DocComment
- DocDef
- EmptyScope
- EmptyTree
- ErasedValueType
- ErasedValueType
- ErroneousAnnotation
- ErrorScope
- ErrorType
- ExistentialExtrapolation
- ExistentialType
- ExistentialType
- ExistentialTypeApi
- ExistentialTypeExtractor
- ExistentialTypeTree
- ExistentialTypeTree
- ExistentialTypeTreeApi
- ExistentialTypeTreeExtractor
- ExistsTypeRefCollector
- ExpansionLimitExceeded
- Expr
- Expr
- FieldMirror
- FilterTreeTraverser
- FilterTypeCollector
- FindTreeTraverser
- FindTypeCollector
- FixedMirrorTreeCreator
- FixedMirrorTypeCreator
- Flag
- FlagAgnosticCompleter
- FlagAssigningCompleter
- FlagOps
- FlagValues
- FoldableConstantType
- FoldableConstantType
- ForEachTypeTraverser
- ForeachPartialTreeTraverser
- ForeachTreeTraverser
- FreeSymbol
- FreeTermSymbol
- FreeTermSymbolApi
- FreeTypeSymbol
- FreeTypeSymbolApi
- FreshNameExtractor
- Function
- Function
- FunctionApi
- FunctionExtractor
- GenPolyType
- GenericApply
- GenericApplyApi
- GlobalMirror
- GlobalPhase
- GlobalPlatform
- GlobalStats
- HKTypeVar
- Ident
- Ident
- IdentApi
- IdentExtractor
- If
- If
- IfApi
- IfExtractor
- ImplDef
- ImplDefApi
- Import
- Import
- ImportApi
- ImportExtractor
- ImportSelector
- ImportSelector
- ImportSelectorApi
- ImportSelectorExtractor
- ImportType
- ImportableAttachment
- Importer
- InfoTransformer
- InjectDerivedValue
- InlineAnnotatedAttachment
- InlineCallsiteAttachment
- InstanceMirror
- InstantiateDependentMap
- InternalApi
- InternalTransformer
- InternalTraverser
- InternalTreeCopierOps
- JavaArgumentApi
- JavaKeywords
- KeepOnlyTypeConstraints
- Keywords
- Kind
- Kind
- KindErrors
- LabelDef
- LabelDef
- LabelDefApi
- LabelDefExtractor
- LazyAnnotationInfo
- LazyPolyType
- LazyTreeCopier
- LazyType
- Liftable
- Liftable
- Literal
- Literal
- LiteralAnnotArg
- LiteralApi
- LiteralExtractor
- LiteralType
- LiteralType
- LocalOwnersTraverser
- Locator
- LookupAmbiguous
- LookupInaccessible
- LookupNotFound
- LookupSucceeded
- MacroCompatApi
- MacroInternalApi
- MalformedType
- MappedBaseTypeSeq
- Match
- Match
- MatchApi
- MatchExtractor
- MemberDef
- MemberDefApi
- MemberScopeApi
- MethodMirror
- MethodSymbol
- MethodSymbolApi
- MethodType
- MethodType
- MethodTypeApi
- MethodTypeExtractor
- MethodValue
- Mirror
- MissingAliasControl
- MissingTypeControl
- Modifiers
- Modifiers
- ModifiersApi
- ModifiersExtractor
- ModuleClassSymbol
- ModuleDef
- ModuleDef
- ModuleDefApi
- ModuleDefExtractor
- ModuleMirror
- ModuleSymbol
- ModuleSymbolApi
- ModuleTypeRef
- Name
- NameApi
- NameLookup
- NameOps
- NameTree
- NameTreeApi
- NamedArg
- NamedArg
- NamedArgApi
- NamedArgExtractor
- NamedType
- NamesApi
- NestedAnnotArg
- New
- New
- NewApi
- NewExtractor
- NoArgsTypeRef
- NoCommonType
- NoCompilationUnit
- NoInlineCallsiteAttachment
- NoPrefix
- NoSymbol
- NoType
- NoWarnAttachment
- NonClassTypeRef
- NullaryMethodType
- NullaryMethodType
- NullaryMethodTypeApi
- NullaryMethodTypeExtractor
- OuterArgCanBeElided
- OverloadedArgProto
- OverloadedType
- PackageClassInfoType
- PackageClassSymbol
- PackageDef
- PackageDef
- PackageDefApi
- PackageDefExtractor
- PackageObjectClassSymbol
- PackageTypeRef
- Parens
- PatVarDefAttachment
- PerRunParsing
- PerRunReporting
- PerRunReportingBase
- PlainAttachment
- PolyType
- PolyType
- PolyTypeApi
- PolyTypeExtractor
- PosAssigner
- PostfixSelect
- ProperTypeKind
- ProtoType
- QualTypeSymAttachment
- Quasiquote
- RawTreePrinter
- RecoverableCyclicReference
- RefTree
- RefTree
- RefTreeApi
- RefTreeExtractor
- ReferenceToBoxed
- ReferenceToBoxed
- ReferenceToBoxedApi
- ReferenceToBoxedExtractor
- RefinedType
- RefinedType
- RefinedType0
- RefinedTypeApi
- RefinedTypeExtractor
- RefinementClassSymbol
- RefinementTypeRef
- ReflectStats
- ReflectiveMirror
- ReificationSupportApi
- ReificationSupportImpl
- RepeatedType
- Return
- Return
- ReturnApi
- ReturnExtractor
- RewrappingTypeProxy
- RootSymbol
- Roots
- RootsBase
- Run
- RunContextApi
- RunParsing
- RunReporting
- RuntimeClassApi
- RuntimeMirror
- SAMFunction
- Scope
- Scope
- ScopeApi
- ScopeEntry
- Select
- Select
- SelectApi
- SelectExtractor
- SelectFromArray
- SelectFromTypeTree
- SelectFromTypeTree
- SelectFromTypeTreeApi
- SelectFromTypeTreeExtractor
- SimpleTypeProxy
- SingleType
- SingleType
- SingleTypeApi
- SingleTypeExtractor
- SingletonType
- SingletonTypeApi
- SingletonTypeTree
- SingletonTypeTree
- SingletonTypeTreeApi
- SingletonTypeTreeExtractor
- StandardImporter
- StandardLiftableInstances
- StandardTypes
- StandardUnliftableInstances
- Star
- Star
- StarApi
- StarExtractor
- StaticallyAnnotatedType
- StrictTreeCopier
- StubClassSymbol
- StubSymbol
- StubTermSymbol
- SubType
- SubTypePair
- SubpatternsAttachment
- SubstMap
- SubstSymMap
- SubstThisMap
- SubstTypeMap
- SubstWildcardMap
- Super
- Super
- SuperApi
- SuperExtractor
- SuperType
- SuperType
- SuperTypeApi
- SuperTypeExtractor
- SymLoader
- SymTree
- SymTreeApi
- Symbol
- SymbolApi
- SymbolContextApiImpl
- SymbolNames
- SymbolOps
- SymbolTableInternal
- Template
- Template
- TemplateApi
- TemplateExtractor
- TemplateMirror
- TermName
- TermName
- TermNameApi
- TermNameExtractor
- TermNames
- TermNamesApi
- TermSymbol
- TermSymbolApi
- TermTree
- TermTreeApi
- This
- This
- ThisApi
- ThisExtractor
- ThisSubstituter
- ThisType
- ThisType
- ThisTypeApi
- ThisTypeExtractor
- Throw
- Throw
- ThrowApi
- ThrowExtractor
- ThrownException
- Transformer
- Traverser
- Tree
- TreeApi
- TreeContextApiImpl
- TreeCopier
- TreeCopierOps
- TreeGen
- TreePrinter
- TreeReplacer
- TreeStackTraverser
- TreeSubstituter
- TreeSymSubstTraverser
- TreeSymSubstituter
- TreeTypeSubstituter
- Try
- Try
- TryApi
- TryExtractor
- TypTree
- TypTreeApi
- Type
- TypeApi
- TypeApiImpl
- TypeApply
- TypeApply
- TypeApplyApi
- TypeApplyExtractor
- TypeBounds
- TypeBounds
- TypeBoundsApi
- TypeBoundsExtractor
- TypeBoundsTree
- TypeBoundsTree
- TypeBoundsTreeApi
- TypeBoundsTreeExtractor
- TypeCollector
- TypeConKind
- TypeConKind
- TypeConstraint
- TypeDef
- TypeDef
- TypeDefApi
- TypeDefExtractor
- TypeError
- TypeFolder
- TypeMap
- TypeMapTreeSubstituter
- TypeName
- TypeName
- TypeNameApi
- TypeNameExtractor
- TypeNames
- TypeNamesApi
- TypeParamVarargsAttachment
- TypeRef
- TypeRef
- TypeRefApi
- TypeRefExtractor
- TypeSkolem
- TypeSymbol
- TypeSymbolApi
- TypeTag
- TypeTag
- TypeTraverser
- TypeTree
- TypeTree
- TypeTreeApi
- TypeTreeExtractor
- TypeTreeWithDeferredRefCheck
- TypeUnwrapper
- TypeVar
- TypeVar
- Typed
- Typed
- TypedApi
- TypedExtractor
- TypedLocator
- UnApply
- UnApply
- UnApplyApi
- UnApplyExtractor
- UndoLog
- UniqueConstantType
- UniqueErasedValueType
- UniqueLiteralType
- UniqueSingleType
- UniqueSuperType
- UniqueThisType
- UniqueType
- UniqueTypeBounds
- Unliftable
- UnmappableAnnotation
- UntouchableTypeVar
- UseCase
- UseInvokeSpecial
- ValDef
- ValDef
- ValDefApi
- ValDefExtractor
- ValOrDefDef
- ValOrDefDef
- ValOrDefDefApi
- ValidateException
- ValidatingPosAssigner
- ValueClassDefinitions
- VarianceValidator
- VariancedTypeMap
- WeakTypeTag
- WeakTypeTag
- WildcardType
- abstractTypesToBounds
- adaptToNewRunMap
- cleanup
- constfold
- constructors
- definitions
- delambdafy
- dropIllegalStarTypes
- dropSingletonType
- erasure
- explicitOuter
- extensionMethods
- fields
- flatten
- gen
- genBCode
- icodes
- inferKind
- lambdaLift
- mixer
- nme
- noPrint
- noSelfType
- nodePrinters
- noopTransformer
- overridingPairs
- patmat
- pendingSuperCall
- perRunCaches
- pickler
- postErasure
- refChecks
- resetPos
- scalaPrimitives
- specializeTypes
- statistics
- superAccessors
- tailCalls
- terminal
- tpnme
- traceSymbols
- treeBrowsers
- treeChecker
- treeInfo
- typeDebug
- typeDeconstruct
- typer
- uncurry
- unwrapToClass
- unwrapToStableClass
- unwrapWrapperTypes
- wildcardExtrapolation

o

scala.tools.nsc.Global

# extensionMethods

###

#### object extensionMethods extends ExtensionMethods

Source
  Global.scala

Linear Supertypes
ExtensionMethods, TypingTransformers, Transform, SubComponent, AnyRef, Any
Content Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. extensionMethods
2. ExtensionMethods
3. TypingTransformers
4. Transform
5. SubComponent
6. AnyRef
7. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  abstract class StdPhase extends GlobalPhase

   A standard phase template

   A standard phase template

   Definition Classes
     SubComponent
2.  class Extender extends TypingTransformer
   Definition Classes
     ExtensionMethods
3.  final class SubstututeRecursion extends TypingTransformer
   Definition Classes
     ExtensionMethods
4.  class Phase extends StdPhase

   The phase defined by this transform

   The phase defined by this transform

   Definition Classes
     Transform
5.  abstract class TypingTransformer extends Global.Transformer
   Definition Classes
     TypingTransformers

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  final def afterOwnPhase[T](op: => T): T
   Definition Classes
     SubComponent
   Annotations
     @inline()
5.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
6.  final def beforeOwnPhase[T](op: => T): T
   Definition Classes
     SubComponent
   Annotations
     @inline()
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
8.  def enabled: Boolean

   Is this component enabled? Default is true.

   Is this component enabled? Default is true.

   Definition Classes
     SubComponent
9.  final def eq(arg0: AnyRef): Boolean
   Definition Classes
     AnyRef
10.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
11.  def extensionMethod(imeth: Global.Symbol): Global.Symbol

    Return the extension method that corresponds to given instance method `meth`.

    Return the extension method that corresponds to given instance method `meth`.

    Definition Classes
      ExtensionMethods
12.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
13.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
14.  val global: Global.this.type

    The global environment; overridden by instantiation in Global.

    The global environment; overridden by instantiation in Global.

    Definition Classes
      extensionMethods → TypingTransformers → SubComponent
15.  def hashCode(): Int

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    Definition Classes
      SubComponent → AnyRef → Any
16.  val initial: Boolean

    True if this phase runs before all other phases.

    True if this phase runs before all other phases. Usually, `parser`.

    Definition Classes
      SubComponent
17.  val internal: Boolean

    True if this phase is not provided by a plug-in.

    True if this phase is not provided by a plug-in.

    Definition Classes
      SubComponent
18.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
19.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
20.  def newPhase(prev: nsc.Phase): StdPhase

    Create a new phase which applies transformer

    Create a new phase which applies transformer

    Definition Classes
      Transform → SubComponent
21.  def newTransformer(unit: Global.CompilationUnit): Global.Transformer

    The transformer factory

    The transformer factory

    Definition Classes
      ExtensionMethods → Transform
22.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
23.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
24.  def ownPhase: nsc.Phase

    The phase corresponding to this subcomponent in the current compiler run

    The phase corresponding to this subcomponent in the current compiler run

    Definition Classes
      SubComponent
25.  val phaseName: String

    the following two members override abstract members in Transform

    the following two members override abstract members in Transform

    Definition Classes
      ExtensionMethods → SubComponent
26.  def phaseNewFlags: Long

    New flags defined by the phase which are not valid before

    New flags defined by the phase which are not valid before

    Definition Classes
      SubComponent
27.  def phaseNextFlags: Long

    New flags defined by the phase which are not valid until immediately after it

    New flags defined by the phase which are not valid until immediately after it

    Definition Classes
      SubComponent
28.  val requires: List[String]

    Names of phases required by this component.

    Names of phases required by this component. Default is `Nil`.

    Definition Classes
      SubComponent
29.  val runsAfter: collection.immutable.List[String]

    Names of phases that must run before this phase.

    Names of phases that must run before this phase.

    Definition Classes
      extensionMethods → SubComponent
30.  val runsBefore: List[String]

    Names of phases that must run after this phase.

    Names of phases that must run after this phase. Default is `Nil`.

    Definition Classes
      SubComponent
31.  val runsRightAfter: None.type

    Name of the phase that this phase must follow immediately.

    Name of the phase that this phase must follow immediately.

    Definition Classes
      extensionMethods → SubComponent
32.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
33.  val terminal: Boolean

    True if this phase runs after all other phases.

    True if this phase runs after all other phases. Usually, `terminal`.

    Definition Classes
      SubComponent
34.  def toString(): String
    Definition Classes
      AnyRef → Any
35.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
36.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
37.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
38.  object ExtensionMethodType

    Recognize a MethodType which represents an extension method.

    Recognize a MethodType which represents an extension method.

    It may have a curried parameter list with the `$this` alone in the first parameter list, in which case that parameter list is dropped. Or, since the curried lists disappear during uncurry, it may have a single parameter list with `$this` as the first parameter, in which case that parameter is removed from the list.

    Definition Classes
      ExtensionMethods

### Inherited from ExtensionMethods

### Inherited from TypingTransformers

### Inherited from Transform

### Inherited from SubComponent

### Inherited from AnyRef

### Inherited from Any

### Ungrouped